﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace pipeline
{
    public partial class Dashboard : UserControl
    {
        private Stream _stream;

        public Dashboard(Stream stream)
        {
            _stream = stream;
            InitializeComponent();

            request.AutoCompleteMode = AutoCompleteMode.Suggest;
            request.AutoCompleteSource = AutoCompleteSource.CustomSource;
            request.AutoCompleteCustomSource = new AutoCompleteStringCollection();

            foreach (var line in Properties.Settings.Default.history)
            {
                request.AutoCompleteCustomSource.Add(line);
            }

            if (request.AutoCompleteCustomSource.Count != 0)
                request.Text = request.AutoCompleteCustomSource[request.AutoCompleteCustomSource.Count - 1];
        }

        private void request_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                Console.WriteLine("asas");
                send.PerformClick();
            }
        }

        private void send_Click(object sender, EventArgs e)
        {
            var stream_reader = new StreamReader(_stream, Encoding.UTF8);
            var stream_writer = new StreamWriter(_stream, new UTF8Encoding(false)) { AutoFlush = true };
            
            var question = request.Text.Trim();
            stream_writer.WriteLine(request.Text.Trim());
            
            var answer = string.Format("{0}# {1}\n", DateTime.UtcNow, stream_reader.ReadLine().Trim().Replace("\\r\\n", "\n"));
            response.Lines = response.Lines.Concat(answer.Split(new char[] { '\n' })).ToArray();

            var history = Properties.Settings.Default.history;
            if (!history.Contains(question))
            {
                request.AutoCompleteCustomSource.Add(question);
                history.Add(question);
                Properties.Settings.Default.Save();
            }

        }

        private void disconnect_Click(object sender, EventArgs e)
        {
            Visible = false;
        }

        private void clearTool_Click(object sender, EventArgs e)
        {
            response.Clear();
        }
    }
}
