﻿namespace pipeline
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.Drawing;
    using System.Text;
    using System.Windows.Forms;
    using System.Diagnostics;
    using System.Xml.Linq;
    using System.Net.Sockets;

    partial class OptionEditor : Form
    {
        Color _originalTextColor;

        public OptionEditor()
        {
            InitializeComponent();

            _originalTextColor = kmlPath.ForeColor;
        }

        public int Port
        {
            get
            {
                return (int)portValue.Value;
            }

            set
            {
                portValue.Value = value;
            }
        }

        public string KmlPath
        {
            get
            {
                return kmlPath.Text; 
            }

            set
            {
                kmlPath.Text = value;
            }
        }

        private void chooseFile_Click(object sender, EventArgs e)
        {
            if (fileOpen.ShowDialog() != DialogResult.OK)
                return;

            try
            {
                XDocument.Load(fileOpen.FileName);
                kmlPath.ForeColor = _originalTextColor;
                kmlPath.Text = fileOpen.FileName;
            }
            catch (Exception ex)
            {
                Debug.Print(ex.Message);
                kmlPath.ForeColor = Color.Red;
                kmlPath.Focus();
            }
        }
    }
}
